#!/bin/bash
#SBATCH -e /dev/null
#SBATCH -o /dev/null
#SBATCH -c 2
#SBATCH -a 1-30
#SBATCH --qos=unlimited
#SBATCH --partition=octa
#SBATCH -t 00:00:7200
#SBATCH --mem=8000M
#SBATCH -D /barrett/scratch/preiner/prop/fmcad20-exps/sygus/run3

set -e -o pipefail

ARGS="$(sed ${SLURM_ARRAY_TASK_ID}'q;d' /barrett/scratch/preiner/prop/fmcad20-exps/sygus/run3/ic_cc_sygus/benchmarks)"
LOGDIR="/barrett/scratch/preiner/prop/fmcad20-exps/sygus/run3/ic_cc_sygus/${ARGS#/barrett/scratch/preiner/prop/fmcad20-exps/sygus/benchmarks/}"
mkdir -p "$LOGDIR"
out="$LOGDIR/run.out"
OUTPUT="$LOGDIR/output.log"

export ARGS
export OUTPUT
export LOGDIR
(
  echo "c host:       $(hostname)"
  echo "c start:      $(date)"
  echo "c arrayjobid: ${SLURM_ARRAY_JOB_ID}"
  echo "c jobid:      ${SLURM_JOB_ID}"
  echo "c command:    /barrett/scratch/preiner/prop/fmcad20-exps/sygus/run3/cvc4  "$ARGS""
  echo "c args:       $ARGS"

  runexec --timelimit 7200 --memlimit 8000MB --dir "$LOGDIR" --full-access-dir "$LOGDIR" --output "${OUTPUT}" -- /barrett/scratch/preiner/prop/fmcad20-exps/sygus/run3/cvc4  "$ARGS"

  echo "c done"
) > "$out" 2>&1
