(set-logic BV)

(declare-const inv_s (_ BitVec 27))
(declare-const t (_ BitVec 27))
(declare-const xlo (_ BitVec 27))
(declare-const xhi (_ BitVec 27))

(define-fun mcb ((xlo (_ BitVec 27)) (xhi (_ BitVec 27)) (v (_ BitVec 27))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 27))) (_ BitVec 27)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (_ bv27 27) (_ bv26 27)) (_ bv25 27)) (_ bv24 27)) (_ bv23 27)) (_ bv22 27)) (_ bv21 27)) (_ bv20 27)) (_ bv19 27)) (_ bv18 27)) (_ bv17 27)) (_ bv16 27)) (_ bv15 27)) (_ bv14 27)) (_ bv13 27)) (_ bv12 27)) (_ bv11 27)) (_ bv10 27)) (_ bv9 27)) (_ bv8 27)) (_ bv7 27)) (_ bv6 27)) (_ bv5 27)) (_ bv4 27)) (_ bv3 27)) (_ bv2 27)) (_ bv1 27)) (_ bv0 27))
)

(define-fun clz ((v (_ BitVec 27))) (_ BitVec 27)
 (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv27 27) (_ bv26 27)) (_ bv25 27)) (_ bv24 27)) (_ bv23 27)) (_ bv22 27)) (_ bv21 27)) (_ bv20 27)) (_ bv19 27)) (_ bv18 27)) (_ bv17 27)) (_ bv16 27)) (_ bv15 27)) (_ bv14 27)) (_ bv13 27)) (_ bv12 27)) (_ bv11 27)) (_ bv10 27)) (_ bv9 27)) (_ bv8 27)) (_ bv7 27)) (_ bv6 27)) (_ bv5 27)) (_ bv4 27)) (_ bv3 27)) (_ bv2 27)) (_ bv1 27)) (_ bv0 27))
)

(define-fun cto ((v (_ BitVec 27))) (_ BitVec 27)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 27))) (_ BitVec 27)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 27))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 27)
 (_ bv0 27)
)

(define-fun one () (_ BitVec 27)
 (_ bv1 27)
)

(define-fun ones () (_ BitVec 27)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 27)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 27)
 (bvnot mins)
)

(define-fun w () (_ BitVec 27)
 (_ bv27 27)
)

(define-fun msb ((v (_ BitVec 27))) (_ BitVec 1)
 ((_ extract 26 26) v)
)

(define-fun CC ((t (_ BitVec 27)) (xlo (_ BitVec 27)) (xhi (_ BitVec 27))) Bool
 (or (= t zero) (= t ones) (exists ((i (_ BitVec 27))) (and (bvult i (ite (= (msb t) #b1) (clo t) (clz t))) (mcb xlo xhi i))))
)

(define-fun LIT ((x (_ BitVec 27)) (s (_ BitVec 27))) Bool
 (= (bvashr s x) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 27)) (s (_ BitVec 27)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)
