(set-logic BV)

(declare-const inv_s (_ BitVec 2))
(declare-const t (_ BitVec 2))
(declare-const xlo (_ BitVec 2))
(declare-const xhi (_ BitVec 2))

(define-fun mcb ((xlo (_ BitVec 2)) (xhi (_ BitVec 2)) (v (_ BitVec 2))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 2))) (_ BitVec 2)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (_ bv2 2) (_ bv1 2)) (_ bv0 2))
)

(define-fun clz ((v (_ BitVec 2))) (_ BitVec 2)
 (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv2 2) (_ bv1 2)) (_ bv0 2))
)

(define-fun cto ((v (_ BitVec 2))) (_ BitVec 2)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 2))) (_ BitVec 2)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 2))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 2)
 (_ bv0 2)
)

(define-fun one () (_ BitVec 2)
 (_ bv1 2)
)

(define-fun ones () (_ BitVec 2)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 2)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 2)
 (bvnot mins)
)

(define-fun w () (_ BitVec 2)
 (_ bv2 2)
)

(define-fun msb ((v (_ BitVec 2))) (_ BitVec 1)
 ((_ extract 1 1) v)
)

(define-fun CC ((t (_ BitVec 2)) (xlo (_ BitVec 2)) (xhi (_ BitVec 2))) Bool
 (and (=> (or (= t zero) (= t ones)) (exists ((i (_ BitVec 2))) (and (= (msb i) (msb t)) (mcb xlo xhi i)))) (=> (and (distinct t zero) (distinct t ones)) (exists ((i (_ BitVec 2))) (and (bvule i (ite (= (msb (bvshl t i)) #b1) (clo t) (clz t))) (mcb (bvashr xlo i) (bvashr xhi i) t)))))
)

(define-fun LIT ((x (_ BitVec 2)) (s (_ BitVec 2))) Bool
 (= (bvashr x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 2)) (s (_ BitVec 2)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)
