(set-logic BV)

(declare-const inv_s (_ BitVec 28))
(declare-const t (_ BitVec 28))
(declare-const xlo (_ BitVec 28))
(declare-const xhi (_ BitVec 28))

(define-fun mcb ((xlo (_ BitVec 28)) (xhi (_ BitVec 28)) (v (_ BitVec 28))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 28))) (_ BitVec 28)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (_ bv28 28) (_ bv27 28)) (_ bv26 28)) (_ bv25 28)) (_ bv24 28)) (_ bv23 28)) (_ bv22 28)) (_ bv21 28)) (_ bv20 28)) (_ bv19 28)) (_ bv18 28)) (_ bv17 28)) (_ bv16 28)) (_ bv15 28)) (_ bv14 28)) (_ bv13 28)) (_ bv12 28)) (_ bv11 28)) (_ bv10 28)) (_ bv9 28)) (_ bv8 28)) (_ bv7 28)) (_ bv6 28)) (_ bv5 28)) (_ bv4 28)) (_ bv3 28)) (_ bv2 28)) (_ bv1 28)) (_ bv0 28))
)

(define-fun clz ((v (_ BitVec 28))) (_ BitVec 28)
 (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv28 28) (_ bv27 28)) (_ bv26 28)) (_ bv25 28)) (_ bv24 28)) (_ bv23 28)) (_ bv22 28)) (_ bv21 28)) (_ bv20 28)) (_ bv19 28)) (_ bv18 28)) (_ bv17 28)) (_ bv16 28)) (_ bv15 28)) (_ bv14 28)) (_ bv13 28)) (_ bv12 28)) (_ bv11 28)) (_ bv10 28)) (_ bv9 28)) (_ bv8 28)) (_ bv7 28)) (_ bv6 28)) (_ bv5 28)) (_ bv4 28)) (_ bv3 28)) (_ bv2 28)) (_ bv1 28)) (_ bv0 28))
)

(define-fun cto ((v (_ BitVec 28))) (_ BitVec 28)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 28))) (_ BitVec 28)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 28))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 28)
 (_ bv0 28)
)

(define-fun one () (_ BitVec 28)
 (_ bv1 28)
)

(define-fun ones () (_ BitVec 28)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 28)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 28)
 (bvnot mins)
)

(define-fun w () (_ BitVec 28)
 (_ bv28 28)
)

(define-fun msb ((v (_ BitVec 28))) (_ BitVec 1)
 ((_ extract 27 27) v)
)

(define-fun CC ((t (_ BitVec 28)) (xlo (_ BitVec 28)) (xhi (_ BitVec 28))) Bool
 (and (=> (or (= t zero) (= t ones)) (exists ((i (_ BitVec 28))) (and (= (msb i) (msb t)) (mcb xlo xhi i)))) (=> (and (distinct t zero) (distinct t ones)) (exists ((i (_ BitVec 28))) (and (bvule i (ite (= (msb (bvshl t i)) #b1) (clo t) (clz t))) (mcb (bvashr xlo i) (bvashr xhi i) t)))))
)

(define-fun LIT ((x (_ BitVec 28)) (s (_ BitVec 28))) Bool
 (= (bvashr x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 28)) (s (_ BitVec 28)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)
