(set-logic BV)

(declare-const inv_s (_ BitVec 15))
(declare-const t (_ BitVec 15))
(declare-const xlo (_ BitVec 15))
(declare-const xhi (_ BitVec 15))

(define-fun mcb ((xlo (_ BitVec 15)) (xhi (_ BitVec 15)) (v (_ BitVec 15))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 15))) (_ BitVec 15)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (_ bv15 15) (_ bv14 15)) (_ bv13 15)) (_ bv12 15)) (_ bv11 15)) (_ bv10 15)) (_ bv9 15)) (_ bv8 15)) (_ bv7 15)) (_ bv6 15)) (_ bv5 15)) (_ bv4 15)) (_ bv3 15)) (_ bv2 15)) (_ bv1 15)) (_ bv0 15))
)

(define-fun clz ((v (_ BitVec 15))) (_ BitVec 15)
 (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv15 15) (_ bv14 15)) (_ bv13 15)) (_ bv12 15)) (_ bv11 15)) (_ bv10 15)) (_ bv9 15)) (_ bv8 15)) (_ bv7 15)) (_ bv6 15)) (_ bv5 15)) (_ bv4 15)) (_ bv3 15)) (_ bv2 15)) (_ bv1 15)) (_ bv0 15))
)

(define-fun cto ((v (_ BitVec 15))) (_ BitVec 15)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 15))) (_ BitVec 15)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 15))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 15)
 (_ bv0 15)
)

(define-fun one () (_ BitVec 15)
 (_ bv1 15)
)

(define-fun ones () (_ BitVec 15)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 15)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 15)
 (bvnot mins)
)

(define-fun w () (_ BitVec 15)
 (_ bv15 15)
)

(define-fun msb ((v (_ BitVec 15))) (_ BitVec 1)
 ((_ extract 14 14) v)
)

(define-fun CC ((t (_ BitVec 15)) (xlo (_ BitVec 15)) (xhi (_ BitVec 15))) Bool
 (=> (= xlo xhi) (distinct xlo mins))
)

(define-fun LIT ((x (_ BitVec 15)) (s (_ BitVec 15))) Bool
 (bvslt s x)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 15)) (s (_ BitVec 15)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)
