(set-logic BV)

(declare-const inv_s (_ BitVec 20))
(declare-const t (_ BitVec 20))
(declare-const xlo (_ BitVec 20))
(declare-const xhi (_ BitVec 20))

(define-fun mcb ((xlo (_ BitVec 20)) (xhi (_ BitVec 20)) (v (_ BitVec 20))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 20))) (_ BitVec 20)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (_ bv20 20) (_ bv19 20)) (_ bv18 20)) (_ bv17 20)) (_ bv16 20)) (_ bv15 20)) (_ bv14 20)) (_ bv13 20)) (_ bv12 20)) (_ bv11 20)) (_ bv10 20)) (_ bv9 20)) (_ bv8 20)) (_ bv7 20)) (_ bv6 20)) (_ bv5 20)) (_ bv4 20)) (_ bv3 20)) (_ bv2 20)) (_ bv1 20)) (_ bv0 20))
)

(define-fun clz ((v (_ BitVec 20))) (_ BitVec 20)
 (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv20 20) (_ bv19 20)) (_ bv18 20)) (_ bv17 20)) (_ bv16 20)) (_ bv15 20)) (_ bv14 20)) (_ bv13 20)) (_ bv12 20)) (_ bv11 20)) (_ bv10 20)) (_ bv9 20)) (_ bv8 20)) (_ bv7 20)) (_ bv6 20)) (_ bv5 20)) (_ bv4 20)) (_ bv3 20)) (_ bv2 20)) (_ bv1 20)) (_ bv0 20))
)

(define-fun cto ((v (_ BitVec 20))) (_ BitVec 20)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 20))) (_ BitVec 20)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 20))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 20)
 (_ bv0 20)
)

(define-fun one () (_ BitVec 20)
 (_ bv1 20)
)

(define-fun ones () (_ BitVec 20)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 20)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 20)
 (bvnot mins)
)

(define-fun w () (_ BitVec 20)
 (_ bv20 20)
)

(define-fun msb ((v (_ BitVec 20))) (_ BitVec 1)
 ((_ extract 19 19) v)
)

(define-fun CC ((t (_ BitVec 20)) (xlo (_ BitVec 20)) (xhi (_ BitVec 20))) Bool
 (=> (= xlo xhi) (distinct xlo maxs))
)

(define-fun LIT ((x (_ BitVec 20)) (s (_ BitVec 20))) Bool
 (bvslt x s)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 20)) (s (_ BitVec 20)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)
