(set-logic BV)

(declare-const inv_s (_ BitVec 22))
(declare-const t (_ BitVec 22))
(declare-const xlo (_ BitVec 22))
(declare-const xhi (_ BitVec 22))

(define-fun mcb ((xlo (_ BitVec 22)) (xhi (_ BitVec 22)) (v (_ BitVec 22))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 22))) (_ BitVec 22)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (_ bv22 22) (_ bv21 22)) (_ bv20 22)) (_ bv19 22)) (_ bv18 22)) (_ bv17 22)) (_ bv16 22)) (_ bv15 22)) (_ bv14 22)) (_ bv13 22)) (_ bv12 22)) (_ bv11 22)) (_ bv10 22)) (_ bv9 22)) (_ bv8 22)) (_ bv7 22)) (_ bv6 22)) (_ bv5 22)) (_ bv4 22)) (_ bv3 22)) (_ bv2 22)) (_ bv1 22)) (_ bv0 22))
)

(define-fun clz ((v (_ BitVec 22))) (_ BitVec 22)
 (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv22 22) (_ bv21 22)) (_ bv20 22)) (_ bv19 22)) (_ bv18 22)) (_ bv17 22)) (_ bv16 22)) (_ bv15 22)) (_ bv14 22)) (_ bv13 22)) (_ bv12 22)) (_ bv11 22)) (_ bv10 22)) (_ bv9 22)) (_ bv8 22)) (_ bv7 22)) (_ bv6 22)) (_ bv5 22)) (_ bv4 22)) (_ bv3 22)) (_ bv2 22)) (_ bv1 22)) (_ bv0 22))
)

(define-fun cto ((v (_ BitVec 22))) (_ BitVec 22)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 22))) (_ BitVec 22)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 22))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 22)
 (_ bv0 22)
)

(define-fun one () (_ BitVec 22)
 (_ bv1 22)
)

(define-fun ones () (_ BitVec 22)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 22)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 22)
 (bvnot mins)
)

(define-fun w () (_ BitVec 22)
 (_ bv22 22)
)

(define-fun msb ((v (_ BitVec 22))) (_ BitVec 1)
 ((_ extract 21 21) v)
)

(define-fun CC ((t (_ BitVec 22)) (xlo (_ BitVec 22)) (xhi (_ BitVec 22))) Bool
 (distinct xlo ones)
)

(define-fun LIT ((x (_ BitVec 22)) (s (_ BitVec 22))) Bool
 (bvult x s)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 22)) (s (_ BitVec 22)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)
