(set-logic BV)

(declare-const inv_s (_ BitVec 23))
(declare-const t (_ BitVec 23))
(declare-const xlo (_ BitVec 23))
(declare-const xhi (_ BitVec 23))

(define-fun mcb ((xlo (_ BitVec 23)) (xhi (_ BitVec 23)) (v (_ BitVec 23))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 23))) (_ BitVec 23)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (_ bv23 23) (_ bv22 23)) (_ bv21 23)) (_ bv20 23)) (_ bv19 23)) (_ bv18 23)) (_ bv17 23)) (_ bv16 23)) (_ bv15 23)) (_ bv14 23)) (_ bv13 23)) (_ bv12 23)) (_ bv11 23)) (_ bv10 23)) (_ bv9 23)) (_ bv8 23)) (_ bv7 23)) (_ bv6 23)) (_ bv5 23)) (_ bv4 23)) (_ bv3 23)) (_ bv2 23)) (_ bv1 23)) (_ bv0 23))
)

(define-fun clz ((v (_ BitVec 23))) (_ BitVec 23)
 (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv23 23) (_ bv22 23)) (_ bv21 23)) (_ bv20 23)) (_ bv19 23)) (_ bv18 23)) (_ bv17 23)) (_ bv16 23)) (_ bv15 23)) (_ bv14 23)) (_ bv13 23)) (_ bv12 23)) (_ bv11 23)) (_ bv10 23)) (_ bv9 23)) (_ bv8 23)) (_ bv7 23)) (_ bv6 23)) (_ bv5 23)) (_ bv4 23)) (_ bv3 23)) (_ bv2 23)) (_ bv1 23)) (_ bv0 23))
)

(define-fun cto ((v (_ BitVec 23))) (_ BitVec 23)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 23))) (_ BitVec 23)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 23))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 23)
 (_ bv0 23)
)

(define-fun one () (_ BitVec 23)
 (_ bv1 23)
)

(define-fun ones () (_ BitVec 23)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 23)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 23)
 (bvnot mins)
)

(define-fun w () (_ BitVec 23)
 (_ bv23 23)
)

(define-fun msb ((v (_ BitVec 23))) (_ BitVec 1)
 ((_ extract 22 22) v)
)

(define-fun CC ((t (_ BitVec 23)) (xlo (_ BitVec 23)) (xhi (_ BitVec 23))) Bool
 (distinct xlo ones)
)

(define-fun LIT ((x (_ BitVec 23)) (s (_ BitVec 23))) Bool
 (bvult x s)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 23)) (s (_ BitVec 23)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)
