(set-logic BV)

(declare-const inv_s (_ BitVec 5))
(declare-const t (_ BitVec 5))
(declare-const xlo (_ BitVec 5))
(declare-const xhi (_ BitVec 5))

(define-fun mcb ((xlo (_ BitVec 5)) (xhi (_ BitVec 5)) (v (_ BitVec 5))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 5))) (_ BitVec 5)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (_ bv5 5) (_ bv4 5)) (_ bv3 5)) (_ bv2 5)) (_ bv1 5)) (_ bv0 5))
)

(define-fun clz ((v (_ BitVec 5))) (_ BitVec 5)
 (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv5 5) (_ bv4 5)) (_ bv3 5)) (_ bv2 5)) (_ bv1 5)) (_ bv0 5))
)

(define-fun cto ((v (_ BitVec 5))) (_ BitVec 5)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 5))) (_ BitVec 5)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 5))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 5)
 (_ bv0 5)
)

(define-fun one () (_ BitVec 5)
 (_ bv1 5)
)

(define-fun ones () (_ BitVec 5)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 5)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 5)
 (bvnot mins)
)

(define-fun w () (_ BitVec 5)
 (_ bv5 5)
)

(define-fun msb ((v (_ BitVec 5))) (_ BitVec 1)
 ((_ extract 4 4) v)
)

(define-fun CC ((t (_ BitVec 5)) (xlo (_ BitVec 5)) (xhi (_ BitVec 5))) Bool
 true
)

(define-fun LIT ((x (_ BitVec 5)) (s (_ BitVec 5))) Bool
 (distinct x s)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 5)) (s (_ BitVec 5)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)
