(set-logic BV)

(declare-const inv_s (_ BitVec 12))
(declare-const inv_s_ctz_s (_ BitVec 12))
(declare-const t (_ BitVec 12))
(declare-const xlo (_ BitVec 12))
(declare-const xhi (_ BitVec 12))

(define-fun mcb ((xlo (_ BitVec 12)) (xhi (_ BitVec 12)) (v (_ BitVec 12))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 12))) (_ BitVec 12)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (_ bv12 12) (_ bv11 12)) (_ bv10 12)) (_ bv9 12)) (_ bv8 12)) (_ bv7 12)) (_ bv6 12)) (_ bv5 12)) (_ bv4 12)) (_ bv3 12)) (_ bv2 12)) (_ bv1 12)) (_ bv0 12))
)

(define-fun clz ((v (_ BitVec 12))) (_ BitVec 12)
 (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv12 12) (_ bv11 12)) (_ bv10 12)) (_ bv9 12)) (_ bv8 12)) (_ bv7 12)) (_ bv6 12)) (_ bv5 12)) (_ bv4 12)) (_ bv3 12)) (_ bv2 12)) (_ bv1 12)) (_ bv0 12))
)

(define-fun cto ((v (_ BitVec 12))) (_ BitVec 12)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 12))) (_ BitVec 12)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 12))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 12)
 (_ bv0 12)
)

(define-fun one () (_ BitVec 12)
 (_ bv1 12)
)

(define-fun ones () (_ BitVec 12)
 (bvnot zero)
)

(define-fun w () (_ BitVec 12)
 (_ bv12 12)
)

(define-fun addo ((a (_ BitVec 12)) (b (_ BitVec 12))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 12 12) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 12)) (b (_ BitVec 12))) Bool
 (let ((zext_a ((_ zero_extend 12) a)) (zext_b ((_ zero_extend 12) b)))
  (distinct
   ((_ extract 11 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 12) (_ bv12 12))))
   zero
  )
 )
)

(define-fun CC ((t (_ BitVec 12)) (xlo (_ BitVec 12)) (xhi (_ BitVec 12))) Bool
 (and
  (=> (distinct t ones) (bvuge xhi t))
  (=> (= t zero) (distinct xlo ones))
  (=>
   (and
    (distinct t zero)
    (distinct t ones)
    (distinct t one)
    (not (mcb xlo xhi t))
   )
   (and
    (not (addo t t))
    (exists ((y (_ BitVec 12))(o (_ BitVec 12)))
     (and
      (mcb xlo xhi (bvadd (bvmul y t) o))
      (bvuge y one)
      (bvule o (ite (bvult (bvsub y one)(bvsub xhi (bvmul y t))) (bvsub y one) (bvsub xhi (bvmul y t))))
      (not (mulo y t))
      (not (addo (bvmul y t) o))
     )
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 12)) (s (_ BitVec 12))) Bool
 (= (bvudiv x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))
(assert (distinct xlo xhi))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 12)) (s (_ BitVec 12)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)

