(set-logic BV)

(declare-const inv_s (_ BitVec 18))
(declare-const inv_s_ctz_s (_ BitVec 18))
(declare-const t (_ BitVec 18))
(declare-const xlo (_ BitVec 18))
(declare-const xhi (_ BitVec 18))

(define-fun mcb ((xlo (_ BitVec 18)) (xhi (_ BitVec 18)) (v (_ BitVec 18))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 18))) (_ BitVec 18)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (_ bv18 18) (_ bv17 18)) (_ bv16 18)) (_ bv15 18)) (_ bv14 18)) (_ bv13 18)) (_ bv12 18)) (_ bv11 18)) (_ bv10 18)) (_ bv9 18)) (_ bv8 18)) (_ bv7 18)) (_ bv6 18)) (_ bv5 18)) (_ bv4 18)) (_ bv3 18)) (_ bv2 18)) (_ bv1 18)) (_ bv0 18))
)

(define-fun clz ((v (_ BitVec 18))) (_ BitVec 18)
 (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv18 18) (_ bv17 18)) (_ bv16 18)) (_ bv15 18)) (_ bv14 18)) (_ bv13 18)) (_ bv12 18)) (_ bv11 18)) (_ bv10 18)) (_ bv9 18)) (_ bv8 18)) (_ bv7 18)) (_ bv6 18)) (_ bv5 18)) (_ bv4 18)) (_ bv3 18)) (_ bv2 18)) (_ bv1 18)) (_ bv0 18))
)

(define-fun cto ((v (_ BitVec 18))) (_ BitVec 18)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 18))) (_ BitVec 18)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 18))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 18)
 (_ bv0 18)
)

(define-fun one () (_ BitVec 18)
 (_ bv1 18)
)

(define-fun ones () (_ BitVec 18)
 (bvnot zero)
)

(define-fun w () (_ BitVec 18)
 (_ bv18 18)
)

(define-fun addo ((a (_ BitVec 18)) (b (_ BitVec 18))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 18 18) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 18)) (b (_ BitVec 18))) Bool
 (let ((zext_a ((_ zero_extend 18) a)) (zext_b ((_ zero_extend 18) b)))
  (distinct
   ((_ extract 17 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 18) (_ bv18 18))))
   zero
  )
 )
)

(define-fun CC ((t (_ BitVec 18)) (xlo (_ BitVec 18)) (xhi (_ BitVec 18))) Bool
 (and
  (=> (distinct t ones) (bvuge xhi t))
  (=> (= t zero) (distinct xlo ones))
  (=>
   (and
    (distinct t zero)
    (distinct t ones)
    (distinct t one)
    (not (mcb xlo xhi t))
   )
   (and
    (not (addo t t))
    (exists ((y (_ BitVec 18))(o (_ BitVec 18)))
     (and
      (mcb xlo xhi (bvadd (bvmul y t) o))
      (bvuge y one)
      (bvule o (ite (bvult (bvsub y one)(bvsub xhi (bvmul y t))) (bvsub y one) (bvsub xhi (bvmul y t))))
      (not (mulo y t))
      (not (addo (bvmul y t) o))
     )
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 18)) (s (_ BitVec 18))) Bool
 (= (bvudiv x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))
(assert (distinct xlo xhi))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 18)) (s (_ BitVec 18)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)

