(set-logic BV)

(declare-const inv_s (_ BitVec 6))
(declare-const inv_s_ctz_s (_ BitVec 6))
(declare-const t (_ BitVec 6))
(declare-const xlo (_ BitVec 6))
(declare-const xhi (_ BitVec 6))

(define-fun mcb ((xlo (_ BitVec 6)) (xhi (_ BitVec 6)) (v (_ BitVec 6))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 6))) (_ BitVec 6)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (_ bv6 6) (_ bv5 6)) (_ bv4 6)) (_ bv3 6)) (_ bv2 6)) (_ bv1 6)) (_ bv0 6))
)

(define-fun clz ((v (_ BitVec 6))) (_ BitVec 6)
 (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv6 6) (_ bv5 6)) (_ bv4 6)) (_ bv3 6)) (_ bv2 6)) (_ bv1 6)) (_ bv0 6))
)

(define-fun cto ((v (_ BitVec 6))) (_ BitVec 6)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 6))) (_ BitVec 6)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 6))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 6)
 (_ bv0 6)
)

(define-fun one () (_ BitVec 6)
 (_ bv1 6)
)

(define-fun ones () (_ BitVec 6)
 (bvnot zero)
)

(define-fun w () (_ BitVec 6)
 (_ bv6 6)
)

(define-fun addo ((a (_ BitVec 6)) (b (_ BitVec 6))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 6 6) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 6)) (b (_ BitVec 6))) Bool
 (let ((zext_a ((_ zero_extend 6) a)) (zext_b ((_ zero_extend 6) b)))
  (distinct
   ((_ extract 5 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 6) (_ bv6 6))))
   zero
  )
 )
)

(define-fun CC ((t (_ BitVec 6)) (xlo (_ BitVec 6)) (xhi (_ BitVec 6))) Bool
 (and
  (=> (distinct t ones) (bvuge xhi t))
  (=> (= t zero) (distinct xlo ones))
  (=>
   (and
    (distinct t zero)
    (distinct t ones)
    (distinct t one)
    (not (mcb xlo xhi t))
   )
   (and
    (not (addo t t))
    (exists ((y (_ BitVec 6))(o (_ BitVec 6)))
     (and
      (mcb xlo xhi (bvadd (bvmul y t) o))
      (bvuge y one)
      (bvule o (ite (bvult (bvsub y one)(bvsub xhi (bvmul y t))) (bvsub y one) (bvsub xhi (bvmul y t))))
      (not (mulo y t))
      (not (addo (bvmul y t) o))
     )
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 6)) (s (_ BitVec 6))) Bool
 (= (bvudiv x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))
(assert (distinct xlo xhi))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 6)) (s (_ BitVec 6)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)

