(set-logic BV)

(declare-const inv_s (_ BitVec 24))
(declare-const inv_s_ctz_s (_ BitVec 24))
(declare-const t (_ BitVec 24))
(declare-const xlo (_ BitVec 24))
(declare-const xhi (_ BitVec 24))

(define-fun mcb ((xlo (_ BitVec 24)) (xhi (_ BitVec 24)) (v (_ BitVec 24))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 24))) (_ BitVec 24)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (_ bv24 24) (_ bv23 24)) (_ bv22 24)) (_ bv21 24)) (_ bv20 24)) (_ bv19 24)) (_ bv18 24)) (_ bv17 24)) (_ bv16 24)) (_ bv15 24)) (_ bv14 24)) (_ bv13 24)) (_ bv12 24)) (_ bv11 24)) (_ bv10 24)) (_ bv9 24)) (_ bv8 24)) (_ bv7 24)) (_ bv6 24)) (_ bv5 24)) (_ bv4 24)) (_ bv3 24)) (_ bv2 24)) (_ bv1 24)) (_ bv0 24))
)

(define-fun clz ((v (_ BitVec 24))) (_ BitVec 24)
 (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv24 24) (_ bv23 24)) (_ bv22 24)) (_ bv21 24)) (_ bv20 24)) (_ bv19 24)) (_ bv18 24)) (_ bv17 24)) (_ bv16 24)) (_ bv15 24)) (_ bv14 24)) (_ bv13 24)) (_ bv12 24)) (_ bv11 24)) (_ bv10 24)) (_ bv9 24)) (_ bv8 24)) (_ bv7 24)) (_ bv6 24)) (_ bv5 24)) (_ bv4 24)) (_ bv3 24)) (_ bv2 24)) (_ bv1 24)) (_ bv0 24))
)

(define-fun cto ((v (_ BitVec 24))) (_ BitVec 24)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 24))) (_ BitVec 24)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 24))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 24)
 (_ bv0 24)
)

(define-fun one () (_ BitVec 24)
 (_ bv1 24)
)

(define-fun ones () (_ BitVec 24)
 (bvnot zero)
)

(define-fun w () (_ BitVec 24)
 (_ bv24 24)
)

(define-fun addo ((a (_ BitVec 24)) (b (_ BitVec 24))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 24 24) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 24)) (b (_ BitVec 24))) Bool
 (let ((zext_a ((_ zero_extend 24) a)) (zext_b ((_ zero_extend 24) b)))
  (distinct
   ((_ extract 23 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 24) (_ bv24 24))))
   zero
  )
 )
)

(define-fun CC ((t (_ BitVec 24)) (xlo (_ BitVec 24)) (xhi (_ BitVec 24))) Bool
 (= (bvlshr xlo (bvudiv t xhi)) xlo)
)

(define-fun LIT ((x (_ BitVec 24)) (s (_ BitVec 24))) Bool
 (= (bvurem s x) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 24)) (s (_ BitVec 24)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)

