(set-logic BV)

(declare-const inv_s (_ BitVec 13))
(declare-const inv_s_ctz_s (_ BitVec 13))
(declare-const t (_ BitVec 13))
(declare-const xlo (_ BitVec 13))
(declare-const xhi (_ BitVec 13))

(define-fun mcb ((xlo (_ BitVec 13)) (xhi (_ BitVec 13)) (v (_ BitVec 13))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 13))) (_ BitVec 13)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (_ bv13 13) (_ bv12 13)) (_ bv11 13)) (_ bv10 13)) (_ bv9 13)) (_ bv8 13)) (_ bv7 13)) (_ bv6 13)) (_ bv5 13)) (_ bv4 13)) (_ bv3 13)) (_ bv2 13)) (_ bv1 13)) (_ bv0 13))
)

(define-fun clz ((v (_ BitVec 13))) (_ BitVec 13)
 (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv13 13) (_ bv12 13)) (_ bv11 13)) (_ bv10 13)) (_ bv9 13)) (_ bv8 13)) (_ bv7 13)) (_ bv6 13)) (_ bv5 13)) (_ bv4 13)) (_ bv3 13)) (_ bv2 13)) (_ bv1 13)) (_ bv0 13))
)

(define-fun cto ((v (_ BitVec 13))) (_ BitVec 13)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 13))) (_ BitVec 13)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 13))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 13)
 (_ bv0 13)
)

(define-fun one () (_ BitVec 13)
 (_ bv1 13)
)

(define-fun ones () (_ BitVec 13)
 (bvnot zero)
)

(define-fun w () (_ BitVec 13)
 (_ bv13 13)
)

(define-fun addo ((a (_ BitVec 13)) (b (_ BitVec 13))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 13 13) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 13)) (b (_ BitVec 13))) Bool
 (let ((zext_a ((_ zero_extend 13) a)) (zext_b ((_ zero_extend 13) b)))
  (distinct
   ((_ extract 12 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 13) (_ bv13 13))))
   zero
  )
 )
)

(define-fun CC ((t (_ BitVec 13)) (xlo (_ BitVec 13)) (xhi (_ BitVec 13))) Bool
 (and
  (=> (= t ones) (mcb xlo xhi ones))
  (=>
   (distinct t ones)
   (and
    (=>
     (bvugt t (bvsub ones t))
     (mcb xlo xhi t)
    )
    (=>
      (bvule t (bvsub ones t))
      (or
       (mcb xlo xhi t)
       (exists ((y (_ BitVec 13)))
        (and
         (mcb xlo xhi y)
         (bvugt y (bvadd t t))
       )
      )
     )
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 13)) (s (_ BitVec 13))) Bool
 (= (bvurem x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 13)) (s (_ BitVec 13)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)

