(set-logic BV)

(declare-const s (_ BitVec 6))
(declare-const inv_s (_ BitVec 6))
(declare-const t (_ BitVec 6))
(declare-const xlo (_ BitVec 6))
(declare-const xhi (_ BitVec 6))

(define-fun mcb ((xlo (_ BitVec 6)) (xhi (_ BitVec 6)) (v (_ BitVec 6))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 6))) (_ BitVec 6)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (_ bv6 6) (_ bv5 6)) (_ bv4 6)) (_ bv3 6)) (_ bv2 6)) (_ bv1 6)) (_ bv0 6))
)

(define-fun clz ((v (_ BitVec 6))) (_ BitVec 6)
 (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv6 6) (_ bv5 6)) (_ bv4 6)) (_ bv3 6)) (_ bv2 6)) (_ bv1 6)) (_ bv0 6))
)

(define-fun cto ((v (_ BitVec 6))) (_ BitVec 6)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 6))) (_ BitVec 6)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 6))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 6)
 (_ bv0 6)
)

(define-fun one () (_ BitVec 6)
 (_ bv1 6)
)

(define-fun ones () (_ BitVec 6)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 6)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 6)
 (bvnot mins)
)

(define-fun w () (_ BitVec 6)
 (_ bv6 6)
)

(define-fun msb ((v (_ BitVec 6))) (_ BitVec 1)
 ((_ extract 5 5) v)
)

(define-fun IC ((s (_ BitVec 6)) (t (_ BitVec 6)) (xlo (_ BitVec 6)) (xhi (_ BitVec 6))) Bool
 (and (= (bvand s t) t) (= (bvand s xhi (bvxnor xlo xhi)) (bvand t (bvxnor xlo xhi))))
)

(define-fun LIT ((x (_ BitVec 6))) Bool
 (= (bvand x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 6)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
