(set-logic BV)

(declare-const s (_ BitVec 32))
(declare-const inv_s (_ BitVec 32))
(declare-const t (_ BitVec 32))
(declare-const xlo (_ BitVec 32))
(declare-const xhi (_ BitVec 32))

(define-fun mcb ((xlo (_ BitVec 32)) (xhi (_ BitVec 32)) (v (_ BitVec 32))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 32))) (_ BitVec 32)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (_ bv32 32) (_ bv31 32)) (_ bv30 32)) (_ bv29 32)) (_ bv28 32)) (_ bv27 32)) (_ bv26 32)) (_ bv25 32)) (_ bv24 32)) (_ bv23 32)) (_ bv22 32)) (_ bv21 32)) (_ bv20 32)) (_ bv19 32)) (_ bv18 32)) (_ bv17 32)) (_ bv16 32)) (_ bv15 32)) (_ bv14 32)) (_ bv13 32)) (_ bv12 32)) (_ bv11 32)) (_ bv10 32)) (_ bv9 32)) (_ bv8 32)) (_ bv7 32)) (_ bv6 32)) (_ bv5 32)) (_ bv4 32)) (_ bv3 32)) (_ bv2 32)) (_ bv1 32)) (_ bv0 32))
)

(define-fun clz ((v (_ BitVec 32))) (_ BitVec 32)
 (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv32 32) (_ bv31 32)) (_ bv30 32)) (_ bv29 32)) (_ bv28 32)) (_ bv27 32)) (_ bv26 32)) (_ bv25 32)) (_ bv24 32)) (_ bv23 32)) (_ bv22 32)) (_ bv21 32)) (_ bv20 32)) (_ bv19 32)) (_ bv18 32)) (_ bv17 32)) (_ bv16 32)) (_ bv15 32)) (_ bv14 32)) (_ bv13 32)) (_ bv12 32)) (_ bv11 32)) (_ bv10 32)) (_ bv9 32)) (_ bv8 32)) (_ bv7 32)) (_ bv6 32)) (_ bv5 32)) (_ bv4 32)) (_ bv3 32)) (_ bv2 32)) (_ bv1 32)) (_ bv0 32))
)

(define-fun cto ((v (_ BitVec 32))) (_ BitVec 32)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 32))) (_ BitVec 32)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 32))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 32)
 (_ bv0 32)
)

(define-fun one () (_ BitVec 32)
 (_ bv1 32)
)

(define-fun ones () (_ BitVec 32)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 32)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 32)
 (bvnot mins)
)

(define-fun w () (_ BitVec 32)
 (_ bv32 32)
)

(define-fun msb ((v (_ BitVec 32))) (_ BitVec 1)
 ((_ extract 31 31) v)
)

(define-fun IC ((s (_ BitVec 32)) (t (_ BitVec 32)) (xlo (_ BitVec 32)) (xhi (_ BitVec 32))) Bool
 (and (=> (= (msb s) #b0) (let ((y (bvsub (clz t) (clz s)))) (and (bvule (clz s) (clz t)) (=> (distinct t zero) (= (bvlshr s y) t)) (=> (= t zero) (or (bvuge xhi y) (= s zero))) (=> (distinct t zero) (mcb xlo xhi y))))) (=> (= (msb s) #b1) (let ((y (bvsub (clz (bvnot t)) (clz (bvnot s))))) (and (bvule (clz (bvnot s)) (clz (bvnot t))) (=> (distinct (bvnot t) zero) (= (bvlshr (bvnot s) y) (bvnot t))) (=> (= (bvnot t) zero) (or (bvuge xhi y) (= (bvnot s) zero))) (=> (distinct (bvnot t) zero) (mcb xlo xhi y))))))
)

(define-fun LIT ((x (_ BitVec 32))) Bool
 (= (bvashr s x) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 32)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
