(set-logic BV)

(declare-const s (_ BitVec 7))
(declare-const inv_s (_ BitVec 7))
(declare-const t (_ BitVec 7))
(declare-const xlo (_ BitVec 7))
(declare-const xhi (_ BitVec 7))

(define-fun mcb ((xlo (_ BitVec 7)) (xhi (_ BitVec 7)) (v (_ BitVec 7))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 7))) (_ BitVec 7)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (_ bv7 7) (_ bv6 7)) (_ bv5 7)) (_ bv4 7)) (_ bv3 7)) (_ bv2 7)) (_ bv1 7)) (_ bv0 7))
)

(define-fun clz ((v (_ BitVec 7))) (_ BitVec 7)
 (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv7 7) (_ bv6 7)) (_ bv5 7)) (_ bv4 7)) (_ bv3 7)) (_ bv2 7)) (_ bv1 7)) (_ bv0 7))
)

(define-fun cto ((v (_ BitVec 7))) (_ BitVec 7)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 7))) (_ BitVec 7)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 7))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 7)
 (_ bv0 7)
)

(define-fun one () (_ BitVec 7)
 (_ bv1 7)
)

(define-fun ones () (_ BitVec 7)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 7)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 7)
 (bvnot mins)
)

(define-fun w () (_ BitVec 7)
 (_ bv7 7)
)

(define-fun msb ((v (_ BitVec 7))) (_ BitVec 1)
 ((_ extract 6 6) v)
)

(define-fun IC ((s (_ BitVec 7)) (t (_ BitVec 7)) (xlo (_ BitVec 7)) (xhi (_ BitVec 7))) Bool
 (and (= (bvlshr (bvshl t s) s) t) (mcb (bvlshr xlo s) (bvlshr xhi s) t))
)

(define-fun LIT ((x (_ BitVec 7))) Bool
 (= (bvlshr x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 7)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
