(set-logic BV)

(declare-const s (_ BitVec 10))
(declare-const t (_ BitVec 10))
(declare-const xlo (_ BitVec 10))
(declare-const xhi (_ BitVec 10))

(define-fun mcb ((xlo (_ BitVec 10)) (xhi (_ BitVec 10)) (v (_ BitVec 10))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 10))) (_ BitVec 10)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (_ bv10 10) (_ bv9 10)) (_ bv8 10)) (_ bv7 10)) (_ bv6 10)) (_ bv5 10)) (_ bv4 10)) (_ bv3 10)) (_ bv2 10)) (_ bv1 10)) (_ bv0 10))
)

(define-fun clz ((v (_ BitVec 10))) (_ BitVec 10)
 (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv10 10) (_ bv9 10)) (_ bv8 10)) (_ bv7 10)) (_ bv6 10)) (_ bv5 10)) (_ bv4 10)) (_ bv3 10)) (_ bv2 10)) (_ bv1 10)) (_ bv0 10))
)

(define-fun cto ((v (_ BitVec 10))) (_ BitVec 10)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 10))) (_ BitVec 10)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 10))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 10)
 (_ bv0 10)
)

(define-fun one () (_ BitVec 10)
 (_ bv1 10)
)

(define-fun ones () (_ BitVec 10)
 (bvnot zero)
)

(define-fun w () (_ BitVec 10)
 (_ bv10 10)
)

(define-fun IC ((s (_ BitVec 10)) (t (_ BitVec 10)) (xlo (_ BitVec 10)) (xhi (_ BitVec 10))) Bool
 (and
  (= (bvand (bvor (bvneg s) s) t) t)
  (or
   (= s zero)
   (and
    (=>
     (odd s)
     (exists ((inv_s (_ BitVec 10)))
      (and
       ; modular inverse of s
       (= (bvmul s inv_s) one)
       (mcb xlo xhi (bvmul t inv_s))
      )
     )
    )
    (=>
     (not (odd s))
     (exists ((inv_s_ctz_s (_ BitVec 10)))
      (and
       ; modular inverse of (bvlshr s (ctz s))
       (= (bvmul (bvlshr s (ctz s)) inv_s_ctz_s) one)
       (mcb
        (bvshl xlo (ctz s))
        (bvshl xhi (ctz s))
        (bvshl (bvmul (bvlshr t (ctz s)) inv_s_ctz_s) (ctz s)))
      )
     )
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 10))) Bool
 (= (bvmul x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 10)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)

