(set-logic BV)

(declare-const s (_ BitVec 31))
(declare-const inv_s (_ BitVec 31))
(declare-const t (_ BitVec 31))
(declare-const xlo (_ BitVec 31))
(declare-const xhi (_ BitVec 31))

(define-fun mcb ((xlo (_ BitVec 31)) (xhi (_ BitVec 31)) (v (_ BitVec 31))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 31))) (_ BitVec 31)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (_ bv31 31) (_ bv30 31)) (_ bv29 31)) (_ bv28 31)) (_ bv27 31)) (_ bv26 31)) (_ bv25 31)) (_ bv24 31)) (_ bv23 31)) (_ bv22 31)) (_ bv21 31)) (_ bv20 31)) (_ bv19 31)) (_ bv18 31)) (_ bv17 31)) (_ bv16 31)) (_ bv15 31)) (_ bv14 31)) (_ bv13 31)) (_ bv12 31)) (_ bv11 31)) (_ bv10 31)) (_ bv9 31)) (_ bv8 31)) (_ bv7 31)) (_ bv6 31)) (_ bv5 31)) (_ bv4 31)) (_ bv3 31)) (_ bv2 31)) (_ bv1 31)) (_ bv0 31))
)

(define-fun clz ((v (_ BitVec 31))) (_ BitVec 31)
 (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv31 31) (_ bv30 31)) (_ bv29 31)) (_ bv28 31)) (_ bv27 31)) (_ bv26 31)) (_ bv25 31)) (_ bv24 31)) (_ bv23 31)) (_ bv22 31)) (_ bv21 31)) (_ bv20 31)) (_ bv19 31)) (_ bv18 31)) (_ bv17 31)) (_ bv16 31)) (_ bv15 31)) (_ bv14 31)) (_ bv13 31)) (_ bv12 31)) (_ bv11 31)) (_ bv10 31)) (_ bv9 31)) (_ bv8 31)) (_ bv7 31)) (_ bv6 31)) (_ bv5 31)) (_ bv4 31)) (_ bv3 31)) (_ bv2 31)) (_ bv1 31)) (_ bv0 31))
)

(define-fun cto ((v (_ BitVec 31))) (_ BitVec 31)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 31))) (_ BitVec 31)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 31))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 31)
 (_ bv0 31)
)

(define-fun one () (_ BitVec 31)
 (_ bv1 31)
)

(define-fun ones () (_ BitVec 31)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 31)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 31)
 (bvnot mins)
)

(define-fun w () (_ BitVec 31)
 (_ bv31 31)
)

(define-fun msb ((v (_ BitVec 31))) (_ BitVec 1)
 ((_ extract 30 30) v)
)

(define-fun IC ((s (_ BitVec 31)) (t (_ BitVec 31)) (xlo (_ BitVec 31)) (xhi (_ BitVec 31))) Bool
 (let ((y (bvsub (ctz t) (ctz s)))) (and (bvule (ctz s) (ctz t)) (=> (distinct t zero) (= (bvshl s y) t)) (=> (= t zero) (or (bvuge xhi y) (= s zero))) (=> (distinct t zero) (mcb xlo xhi y))))
)

(define-fun LIT ((x (_ BitVec 31))) Bool
 (= (bvshl s x) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 31)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
