(set-logic BV)

(declare-const s (_ BitVec 64))
(declare-const inv_s (_ BitVec 64))
(declare-const t (_ BitVec 64))
(declare-const xlo (_ BitVec 64))
(declare-const xhi (_ BitVec 64))

(define-fun mcb ((xlo (_ BitVec 64)) (xhi (_ BitVec 64)) (v (_ BitVec 64))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 64))) (_ BitVec 64)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 56 56) v) #b0) (ite (= ((_ extract 57 57) v) #b0) (ite (= ((_ extract 58 58) v) #b0) (ite (= ((_ extract 59 59) v) #b0) (ite (= ((_ extract 60 60) v) #b0) (ite (= ((_ extract 61 61) v) #b0) (ite (= ((_ extract 62 62) v) #b0) (ite (= ((_ extract 63 63) v) #b0) (_ bv64 64) (_ bv63 64)) (_ bv62 64)) (_ bv61 64)) (_ bv60 64)) (_ bv59 64)) (_ bv58 64)) (_ bv57 64)) (_ bv56 64)) (_ bv55 64)) (_ bv54 64)) (_ bv53 64)) (_ bv52 64)) (_ bv51 64)) (_ bv50 64)) (_ bv49 64)) (_ bv48 64)) (_ bv47 64)) (_ bv46 64)) (_ bv45 64)) (_ bv44 64)) (_ bv43 64)) (_ bv42 64)) (_ bv41 64)) (_ bv40 64)) (_ bv39 64)) (_ bv38 64)) (_ bv37 64)) (_ bv36 64)) (_ bv35 64)) (_ bv34 64)) (_ bv33 64)) (_ bv32 64)) (_ bv31 64)) (_ bv30 64)) (_ bv29 64)) (_ bv28 64)) (_ bv27 64)) (_ bv26 64)) (_ bv25 64)) (_ bv24 64)) (_ bv23 64)) (_ bv22 64)) (_ bv21 64)) (_ bv20 64)) (_ bv19 64)) (_ bv18 64)) (_ bv17 64)) (_ bv16 64)) (_ bv15 64)) (_ bv14 64)) (_ bv13 64)) (_ bv12 64)) (_ bv11 64)) (_ bv10 64)) (_ bv9 64)) (_ bv8 64)) (_ bv7 64)) (_ bv6 64)) (_ bv5 64)) (_ bv4 64)) (_ bv3 64)) (_ bv2 64)) (_ bv1 64)) (_ bv0 64))
)

(define-fun clz ((v (_ BitVec 64))) (_ BitVec 64)
 (ite (= ((_ extract 63 63) v) #b0) (ite (= ((_ extract 62 62) v) #b0) (ite (= ((_ extract 61 61) v) #b0) (ite (= ((_ extract 60 60) v) #b0) (ite (= ((_ extract 59 59) v) #b0) (ite (= ((_ extract 58 58) v) #b0) (ite (= ((_ extract 57 57) v) #b0) (ite (= ((_ extract 56 56) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv64 64) (_ bv63 64)) (_ bv62 64)) (_ bv61 64)) (_ bv60 64)) (_ bv59 64)) (_ bv58 64)) (_ bv57 64)) (_ bv56 64)) (_ bv55 64)) (_ bv54 64)) (_ bv53 64)) (_ bv52 64)) (_ bv51 64)) (_ bv50 64)) (_ bv49 64)) (_ bv48 64)) (_ bv47 64)) (_ bv46 64)) (_ bv45 64)) (_ bv44 64)) (_ bv43 64)) (_ bv42 64)) (_ bv41 64)) (_ bv40 64)) (_ bv39 64)) (_ bv38 64)) (_ bv37 64)) (_ bv36 64)) (_ bv35 64)) (_ bv34 64)) (_ bv33 64)) (_ bv32 64)) (_ bv31 64)) (_ bv30 64)) (_ bv29 64)) (_ bv28 64)) (_ bv27 64)) (_ bv26 64)) (_ bv25 64)) (_ bv24 64)) (_ bv23 64)) (_ bv22 64)) (_ bv21 64)) (_ bv20 64)) (_ bv19 64)) (_ bv18 64)) (_ bv17 64)) (_ bv16 64)) (_ bv15 64)) (_ bv14 64)) (_ bv13 64)) (_ bv12 64)) (_ bv11 64)) (_ bv10 64)) (_ bv9 64)) (_ bv8 64)) (_ bv7 64)) (_ bv6 64)) (_ bv5 64)) (_ bv4 64)) (_ bv3 64)) (_ bv2 64)) (_ bv1 64)) (_ bv0 64))
)

(define-fun cto ((v (_ BitVec 64))) (_ BitVec 64)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 64))) (_ BitVec 64)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 64))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 64)
 (_ bv0 64)
)

(define-fun one () (_ BitVec 64)
 (_ bv1 64)
)

(define-fun ones () (_ BitVec 64)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 64)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 64)
 (bvnot mins)
)

(define-fun w () (_ BitVec 64)
 (_ bv64 64)
)

(define-fun msb ((v (_ BitVec 64))) (_ BitVec 1)
 ((_ extract 63 63) v)
)

(define-fun IC ((s (_ BitVec 64)) (t (_ BitVec 64)) (xlo (_ BitVec 64)) (xhi (_ BitVec 64))) Bool
 (and (distinct s maxs) (or (and (= (msb xlo) #b1) (bvslt s xhi)) (and (distinct (msb xlo) #b1) (bvslt s (bvand maxs xhi)))))
)

(define-fun LIT ((x (_ BitVec 64))) Bool
 (bvslt s x)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 64)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
