(set-logic BV)

(declare-const s (_ BitVec 9))
(declare-const inv_s (_ BitVec 9))
(declare-const inv_s_ctz_s (_ BitVec 9))
(declare-const t (_ BitVec 9))
(declare-const xlo (_ BitVec 9))
(declare-const xhi (_ BitVec 9))

(define-fun mcb ((xlo (_ BitVec 9)) (xhi (_ BitVec 9)) (v (_ BitVec 9))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 9))) (_ BitVec 9)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (_ bv9 9) (_ bv8 9)) (_ bv7 9)) (_ bv6 9)) (_ bv5 9)) (_ bv4 9)) (_ bv3 9)) (_ bv2 9)) (_ bv1 9)) (_ bv0 9))
)

(define-fun clz ((v (_ BitVec 9))) (_ BitVec 9)
 (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv9 9) (_ bv8 9)) (_ bv7 9)) (_ bv6 9)) (_ bv5 9)) (_ bv4 9)) (_ bv3 9)) (_ bv2 9)) (_ bv1 9)) (_ bv0 9))
)

(define-fun cto ((v (_ BitVec 9))) (_ BitVec 9)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 9))) (_ BitVec 9)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 9))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 9)
 (_ bv0 9)
)

(define-fun one () (_ BitVec 9)
 (_ bv1 9)
)

(define-fun ones () (_ BitVec 9)
 (bvnot zero)
)

(define-fun w () (_ BitVec 9)
 (_ bv9 9)
)

(define-fun addo ((a (_ BitVec 9)) (b (_ BitVec 9))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 9 9) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 9)) (b (_ BitVec 9))) Bool
 (let ((zext_a ((_ zero_extend 9) a)) (zext_b ((_ zero_extend 9) b)))
  (distinct
   ((_ extract 8 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 9) (_ bv9 9))))
   zero
  )
 )
)

(define-fun IC ((s (_ BitVec 9)) (t (_ BitVec 9)) (xlo (_ BitVec 9)) (xhi (_ BitVec 9))) Bool
 (and
  (= (bvudiv s (bvudiv s t)) t)
  (and
   (=> (distinct t ones) (bvugt xhi zero))
   (=>
    (or (distinct t zero) (distinct s zero))
    (and
     (bvule (bvudiv s xhi) t)
     (exists ((y (_ BitVec 9)))
      (and
       (mcb xlo xhi y)
       (=> (= t ones) (and (bvuge y zero) (bvule y (bvudiv s t))))
       (=>
        (distinct t ones)
        (and
         (bvugt y (bvudiv s (bvadd t one)))
         (bvule y (bvudiv s t))
        )
       )
      )
     )
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 9))) Bool
 (= (bvudiv s x) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 9)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)

