(set-logic BV)

(declare-const s (_ BitVec 33))
(declare-const inv_s (_ BitVec 33))
(declare-const inv_s_ctz_s (_ BitVec 33))
(declare-const t (_ BitVec 33))
(declare-const xlo (_ BitVec 33))
(declare-const xhi (_ BitVec 33))

(define-fun mcb ((xlo (_ BitVec 33)) (xhi (_ BitVec 33)) (v (_ BitVec 33))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 33))) (_ BitVec 33)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (_ bv33 33) (_ bv32 33)) (_ bv31 33)) (_ bv30 33)) (_ bv29 33)) (_ bv28 33)) (_ bv27 33)) (_ bv26 33)) (_ bv25 33)) (_ bv24 33)) (_ bv23 33)) (_ bv22 33)) (_ bv21 33)) (_ bv20 33)) (_ bv19 33)) (_ bv18 33)) (_ bv17 33)) (_ bv16 33)) (_ bv15 33)) (_ bv14 33)) (_ bv13 33)) (_ bv12 33)) (_ bv11 33)) (_ bv10 33)) (_ bv9 33)) (_ bv8 33)) (_ bv7 33)) (_ bv6 33)) (_ bv5 33)) (_ bv4 33)) (_ bv3 33)) (_ bv2 33)) (_ bv1 33)) (_ bv0 33))
)

(define-fun clz ((v (_ BitVec 33))) (_ BitVec 33)
 (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv33 33) (_ bv32 33)) (_ bv31 33)) (_ bv30 33)) (_ bv29 33)) (_ bv28 33)) (_ bv27 33)) (_ bv26 33)) (_ bv25 33)) (_ bv24 33)) (_ bv23 33)) (_ bv22 33)) (_ bv21 33)) (_ bv20 33)) (_ bv19 33)) (_ bv18 33)) (_ bv17 33)) (_ bv16 33)) (_ bv15 33)) (_ bv14 33)) (_ bv13 33)) (_ bv12 33)) (_ bv11 33)) (_ bv10 33)) (_ bv9 33)) (_ bv8 33)) (_ bv7 33)) (_ bv6 33)) (_ bv5 33)) (_ bv4 33)) (_ bv3 33)) (_ bv2 33)) (_ bv1 33)) (_ bv0 33))
)

(define-fun cto ((v (_ BitVec 33))) (_ BitVec 33)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 33))) (_ BitVec 33)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 33))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 33)
 (_ bv0 33)
)

(define-fun one () (_ BitVec 33)
 (_ bv1 33)
)

(define-fun ones () (_ BitVec 33)
 (bvnot zero)
)

(define-fun w () (_ BitVec 33)
 (_ bv33 33)
)

(define-fun addo ((a (_ BitVec 33)) (b (_ BitVec 33))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 33 33) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 33)) (b (_ BitVec 33))) Bool
 (let ((zext_a ((_ zero_extend 33) a)) (zext_b ((_ zero_extend 33) b)))
  (distinct
   ((_ extract 32 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 33) (_ bv33 33))))
   zero
  )
 )
)

(define-fun IC ((s (_ BitVec 33)) (t (_ BitVec 33)) (xlo (_ BitVec 33)) (xhi (_ BitVec 33))) Bool
 (and
  (= (bvudiv (bvmul s t) s) t)
  (=>
   (= t zero)
   (bvult xlo s)
  )
  (=>
   (and (distinct t zero) (distinct s zero))
   (exists ((y (_ BitVec 33)))
    (let ((overflow (or (mulo s (bvadd t one)) (addo t one))))
     (and
      (mcb xlo xhi y)
      (=> (not overflow) (bvult y (bvmul s (bvadd t one))))
      (=> overflow (bvule y ones))
      (bvuge y (bvmul s t))
     )
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 33))) Bool
 (= (bvudiv x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 33)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)

