(set-logic BV)

(declare-const s (_ BitVec 4))
(declare-const inv_s (_ BitVec 4))
(declare-const t (_ BitVec 4))
(declare-const xlo (_ BitVec 4))
(declare-const xhi (_ BitVec 4))

(define-fun mcb ((xlo (_ BitVec 4)) (xhi (_ BitVec 4)) (v (_ BitVec 4))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 4))) (_ BitVec 4)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (_ bv4 4) (_ bv3 4)) (_ bv2 4)) (_ bv1 4)) (_ bv0 4))
)

(define-fun clz ((v (_ BitVec 4))) (_ BitVec 4)
 (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv4 4) (_ bv3 4)) (_ bv2 4)) (_ bv1 4)) (_ bv0 4))
)

(define-fun cto ((v (_ BitVec 4))) (_ BitVec 4)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 4))) (_ BitVec 4)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 4))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 4)
 (_ bv0 4)
)

(define-fun one () (_ BitVec 4)
 (_ bv1 4)
)

(define-fun ones () (_ BitVec 4)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 4)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 4)
 (bvnot mins)
)

(define-fun w () (_ BitVec 4)
 (_ bv4 4)
)

(define-fun msb ((v (_ BitVec 4))) (_ BitVec 1)
 ((_ extract 3 3) v)
)

(define-fun IC ((s (_ BitVec 4)) (t (_ BitVec 4)) (xlo (_ BitVec 4)) (xhi (_ BitVec 4))) Bool
 (and (distinct s zero) (bvult xlo s))
)

(define-fun LIT ((x (_ BitVec 4))) Bool
 (bvult x s)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 4)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
