(set-logic BV)

(declare-const s (_ BitVec 17))
(declare-const t (_ BitVec 17))
(declare-const xlo (_ BitVec 17))
(declare-const xhi (_ BitVec 17))

(define-fun mcb ((xlo (_ BitVec 17)) (xhi (_ BitVec 17)) (v (_ BitVec 17))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 17))) (_ BitVec 17)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (_ bv17 17) (_ bv16 17)) (_ bv15 17)) (_ bv14 17)) (_ bv13 17)) (_ bv12 17)) (_ bv11 17)) (_ bv10 17)) (_ bv9 17)) (_ bv8 17)) (_ bv7 17)) (_ bv6 17)) (_ bv5 17)) (_ bv4 17)) (_ bv3 17)) (_ bv2 17)) (_ bv1 17)) (_ bv0 17))
)

(define-fun clz ((v (_ BitVec 17))) (_ BitVec 17)
 (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv17 17) (_ bv16 17)) (_ bv15 17)) (_ bv14 17)) (_ bv13 17)) (_ bv12 17)) (_ bv11 17)) (_ bv10 17)) (_ bv9 17)) (_ bv8 17)) (_ bv7 17)) (_ bv6 17)) (_ bv5 17)) (_ bv4 17)) (_ bv3 17)) (_ bv2 17)) (_ bv1 17)) (_ bv0 17))
)

(define-fun cto ((v (_ BitVec 17))) (_ BitVec 17)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 17))) (_ BitVec 17)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 17))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 17)
 (_ bv0 17)
)

(define-fun one () (_ BitVec 17)
 (_ bv1 17)
)

(define-fun ones () (_ BitVec 17)
 (bvnot zero)
)

(define-fun w () (_ BitVec 17)
 (_ bv17 17)
)

(define-fun addo ((a (_ BitVec 17)) (b (_ BitVec 17))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 17 17) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 17)) (b (_ BitVec 17))) Bool
 (let ((zext_a ((_ zero_extend 17) a)) (zext_b ((_ zero_extend 17) b)))
  (distinct
   ((_ extract 16 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 17) (_ bv17 17))))
   zero
  )
 )
)

(define-fun IC ((s (_ BitVec 17)) (t (_ BitVec 17)) (xlo (_ BitVec 17)) (xhi (_ BitVec 17))) Bool
 (and
  (bvuge (bvand (bvsub (bvadd t t) s) s) t)
  (=>
   (= s t)
   (or (= xlo zero) (bvugt xhi t))
  )
  (=>
   (distinct s t)
   (exists ((y (_ BitVec 17)))
    (and
     (mcb xlo xhi y)
     (bvugt y t)
     (= (bvurem (bvsub s t) y) zero)
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 17))) Bool
 (= (bvurem s x) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 17)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)

