(set-logic BV)

(declare-const s (_ BitVec 25))
(declare-const t (_ BitVec 25))
(declare-const xlo (_ BitVec 25))
(declare-const xhi (_ BitVec 25))

(define-fun mcb ((xlo (_ BitVec 25)) (xhi (_ BitVec 25)) (v (_ BitVec 25))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 25))) (_ BitVec 25)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (_ bv25 25) (_ bv24 25)) (_ bv23 25)) (_ bv22 25)) (_ bv21 25)) (_ bv20 25)) (_ bv19 25)) (_ bv18 25)) (_ bv17 25)) (_ bv16 25)) (_ bv15 25)) (_ bv14 25)) (_ bv13 25)) (_ bv12 25)) (_ bv11 25)) (_ bv10 25)) (_ bv9 25)) (_ bv8 25)) (_ bv7 25)) (_ bv6 25)) (_ bv5 25)) (_ bv4 25)) (_ bv3 25)) (_ bv2 25)) (_ bv1 25)) (_ bv0 25))
)

(define-fun clz ((v (_ BitVec 25))) (_ BitVec 25)
 (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv25 25) (_ bv24 25)) (_ bv23 25)) (_ bv22 25)) (_ bv21 25)) (_ bv20 25)) (_ bv19 25)) (_ bv18 25)) (_ bv17 25)) (_ bv16 25)) (_ bv15 25)) (_ bv14 25)) (_ bv13 25)) (_ bv12 25)) (_ bv11 25)) (_ bv10 25)) (_ bv9 25)) (_ bv8 25)) (_ bv7 25)) (_ bv6 25)) (_ bv5 25)) (_ bv4 25)) (_ bv3 25)) (_ bv2 25)) (_ bv1 25)) (_ bv0 25))
)

(define-fun cto ((v (_ BitVec 25))) (_ BitVec 25)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 25))) (_ BitVec 25)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 25))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 25)
 (_ bv0 25)
)

(define-fun one () (_ BitVec 25)
 (_ bv1 25)
)

(define-fun ones () (_ BitVec 25)
 (bvnot zero)
)

(define-fun w () (_ BitVec 25)
 (_ bv25 25)
)

(define-fun addo ((a (_ BitVec 25)) (b (_ BitVec 25))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 25 25) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 25)) (b (_ BitVec 25))) Bool
 (let ((zext_a ((_ zero_extend 25) a)) (zext_b ((_ zero_extend 25) b)))
  (distinct
   ((_ extract 24 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 25) (_ bv25 25))))
   zero
  )
 )
)

(define-fun IC ((s (_ BitVec 25)) (t (_ BitVec 25)) (xlo (_ BitVec 25)) (xhi (_ BitVec 25))) Bool
 (and
  (bvuge (bvand (bvsub (bvadd t t) s) s) t)
  (=>
   (= s t)
   (or (= xlo zero) (bvugt xhi t))
  )
  (=>
   (distinct s t)
   (exists ((y (_ BitVec 25)))
    (and
     (mcb xlo xhi y)
     (bvugt y t)
     (= (bvurem (bvsub s t) y) zero)
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 25))) Bool
 (= (bvurem s x) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 25)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)

