(set-logic BV)

(declare-const s (_ BitVec 14))
(declare-const t (_ BitVec 14))
(declare-const xlo (_ BitVec 14))
(declare-const xhi (_ BitVec 14))

(define-fun mcb ((xlo (_ BitVec 14)) (xhi (_ BitVec 14)) (v (_ BitVec 14))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 14))) (_ BitVec 14)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (_ bv14 14) (_ bv13 14)) (_ bv12 14)) (_ bv11 14)) (_ bv10 14)) (_ bv9 14)) (_ bv8 14)) (_ bv7 14)) (_ bv6 14)) (_ bv5 14)) (_ bv4 14)) (_ bv3 14)) (_ bv2 14)) (_ bv1 14)) (_ bv0 14))
)

(define-fun clz ((v (_ BitVec 14))) (_ BitVec 14)
 (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv14 14) (_ bv13 14)) (_ bv12 14)) (_ bv11 14)) (_ bv10 14)) (_ bv9 14)) (_ bv8 14)) (_ bv7 14)) (_ bv6 14)) (_ bv5 14)) (_ bv4 14)) (_ bv3 14)) (_ bv2 14)) (_ bv1 14)) (_ bv0 14))
)

(define-fun cto ((v (_ BitVec 14))) (_ BitVec 14)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 14))) (_ BitVec 14)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 14))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 14)
 (_ bv0 14)
)

(define-fun one () (_ BitVec 14)
 (_ bv1 14)
)

(define-fun ones () (_ BitVec 14)
 (bvnot zero)
)

(define-fun w () (_ BitVec 14)
 (_ bv14 14)
)

(define-fun addo ((a (_ BitVec 14)) (b (_ BitVec 14))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 14 14) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 14)) (b (_ BitVec 14))) Bool
 (let ((zext_a ((_ zero_extend 14) a)) (zext_b ((_ zero_extend 14) b)))
  (distinct
   ((_ extract 13 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 14) (_ bv14 14))))
   zero
  )
 )
)

(define-fun IC ((s (_ BitVec 14)) (t (_ BitVec 14)) (xlo (_ BitVec 14)) (xhi (_ BitVec 14))) Bool
 (and
  (bvuge (bvnot (bvneg s)) t)
  (=>
   (or (= s zero) (= t ones))
   (mcb xlo xhi t)
  )
  (=>
   (and
    (distinct s zero)
    (distinct t ones)
   )
   (exists ((y (_ BitVec 14)))
    (and
     (mcb xlo xhi (bvadd (bvmul s y) t))
     (not (mulo s y))
     (not (addo (bvmul s y) t))
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 14))) Bool
 (= (bvurem x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 14)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)

