(set-logic BV)

(declare-const s (_ BitVec 19))
(declare-const t (_ BitVec 19))
(declare-const xlo (_ BitVec 19))
(declare-const xhi (_ BitVec 19))

(define-fun mcb ((xlo (_ BitVec 19)) (xhi (_ BitVec 19)) (v (_ BitVec 19))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 19))) (_ BitVec 19)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (_ bv19 19) (_ bv18 19)) (_ bv17 19)) (_ bv16 19)) (_ bv15 19)) (_ bv14 19)) (_ bv13 19)) (_ bv12 19)) (_ bv11 19)) (_ bv10 19)) (_ bv9 19)) (_ bv8 19)) (_ bv7 19)) (_ bv6 19)) (_ bv5 19)) (_ bv4 19)) (_ bv3 19)) (_ bv2 19)) (_ bv1 19)) (_ bv0 19))
)

(define-fun clz ((v (_ BitVec 19))) (_ BitVec 19)
 (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv19 19) (_ bv18 19)) (_ bv17 19)) (_ bv16 19)) (_ bv15 19)) (_ bv14 19)) (_ bv13 19)) (_ bv12 19)) (_ bv11 19)) (_ bv10 19)) (_ bv9 19)) (_ bv8 19)) (_ bv7 19)) (_ bv6 19)) (_ bv5 19)) (_ bv4 19)) (_ bv3 19)) (_ bv2 19)) (_ bv1 19)) (_ bv0 19))
)

(define-fun cto ((v (_ BitVec 19))) (_ BitVec 19)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 19))) (_ BitVec 19)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 19))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 19)
 (_ bv0 19)
)

(define-fun one () (_ BitVec 19)
 (_ bv1 19)
)

(define-fun ones () (_ BitVec 19)
 (bvnot zero)
)

(define-fun w () (_ BitVec 19)
 (_ bv19 19)
)

(define-fun addo ((a (_ BitVec 19)) (b (_ BitVec 19))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 19 19) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 19)) (b (_ BitVec 19))) Bool
 (let ((zext_a ((_ zero_extend 19) a)) (zext_b ((_ zero_extend 19) b)))
  (distinct
   ((_ extract 18 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 19) (_ bv19 19))))
   zero
  )
 )
)

(define-fun IC ((s (_ BitVec 19)) (t (_ BitVec 19)) (xlo (_ BitVec 19)) (xhi (_ BitVec 19))) Bool
 (and
  (bvuge (bvnot (bvneg s)) t)
  (=>
   (or (= s zero) (= t ones))
   (mcb xlo xhi t)
  )
  (=>
   (and
    (distinct s zero)
    (distinct t ones)
   )
   (exists ((y (_ BitVec 19)))
    (and
     (mcb xlo xhi (bvadd (bvmul s y) t))
     (not (mulo s y))
     (not (addo (bvmul s y) t))
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 19))) Bool
 (= (bvurem x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 19)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)

