(set-logic BV)

(declare-const s (_ BitVec 21))
(declare-const t (_ BitVec 21))
(declare-const xlo (_ BitVec 21))
(declare-const xhi (_ BitVec 21))

(define-fun mcb ((xlo (_ BitVec 21)) (xhi (_ BitVec 21)) (v (_ BitVec 21))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 21))) (_ BitVec 21)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (_ bv21 21) (_ bv20 21)) (_ bv19 21)) (_ bv18 21)) (_ bv17 21)) (_ bv16 21)) (_ bv15 21)) (_ bv14 21)) (_ bv13 21)) (_ bv12 21)) (_ bv11 21)) (_ bv10 21)) (_ bv9 21)) (_ bv8 21)) (_ bv7 21)) (_ bv6 21)) (_ bv5 21)) (_ bv4 21)) (_ bv3 21)) (_ bv2 21)) (_ bv1 21)) (_ bv0 21))
)

(define-fun clz ((v (_ BitVec 21))) (_ BitVec 21)
 (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv21 21) (_ bv20 21)) (_ bv19 21)) (_ bv18 21)) (_ bv17 21)) (_ bv16 21)) (_ bv15 21)) (_ bv14 21)) (_ bv13 21)) (_ bv12 21)) (_ bv11 21)) (_ bv10 21)) (_ bv9 21)) (_ bv8 21)) (_ bv7 21)) (_ bv6 21)) (_ bv5 21)) (_ bv4 21)) (_ bv3 21)) (_ bv2 21)) (_ bv1 21)) (_ bv0 21))
)

(define-fun cto ((v (_ BitVec 21))) (_ BitVec 21)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 21))) (_ BitVec 21)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 21))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 21)
 (_ bv0 21)
)

(define-fun one () (_ BitVec 21)
 (_ bv1 21)
)

(define-fun ones () (_ BitVec 21)
 (bvnot zero)
)

(define-fun w () (_ BitVec 21)
 (_ bv21 21)
)

(define-fun addo ((a (_ BitVec 21)) (b (_ BitVec 21))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 21 21) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 21)) (b (_ BitVec 21))) Bool
 (let ((zext_a ((_ zero_extend 21) a)) (zext_b ((_ zero_extend 21) b)))
  (distinct
   ((_ extract 20 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 21) (_ bv21 21))))
   zero
  )
 )
)

(define-fun IC ((s (_ BitVec 21)) (t (_ BitVec 21)) (xlo (_ BitVec 21)) (xhi (_ BitVec 21))) Bool
 (and
  (bvuge (bvnot (bvneg s)) t)
  (=>
   (or (= s zero) (= t ones))
   (mcb xlo xhi t)
  )
  (=>
   (and
    (distinct s zero)
    (distinct t ones)
   )
   (exists ((y (_ BitVec 21)))
    (and
     (mcb xlo xhi (bvadd (bvmul s y) t))
     (not (mulo s y))
     (not (addo (bvmul s y) t))
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 21))) Bool
 (= (bvurem x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 21)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)

