(set-logic BV)

(declare-const s (_ BitVec 5))
(declare-const t (_ BitVec 5))
(declare-const xlo (_ BitVec 5))
(declare-const xhi (_ BitVec 5))

(define-fun mcb ((xlo (_ BitVec 5)) (xhi (_ BitVec 5)) (v (_ BitVec 5))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 5))) (_ BitVec 5)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (_ bv5 5) (_ bv4 5)) (_ bv3 5)) (_ bv2 5)) (_ bv1 5)) (_ bv0 5))
)

(define-fun clz ((v (_ BitVec 5))) (_ BitVec 5)
 (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv5 5) (_ bv4 5)) (_ bv3 5)) (_ bv2 5)) (_ bv1 5)) (_ bv0 5))
)

(define-fun cto ((v (_ BitVec 5))) (_ BitVec 5)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 5))) (_ BitVec 5)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 5))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 5)
 (_ bv0 5)
)

(define-fun one () (_ BitVec 5)
 (_ bv1 5)
)

(define-fun ones () (_ BitVec 5)
 (bvnot zero)
)

(define-fun w () (_ BitVec 5)
 (_ bv5 5)
)

(define-fun addo ((a (_ BitVec 5)) (b (_ BitVec 5))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 5 5) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 5)) (b (_ BitVec 5))) Bool
 (let ((zext_a ((_ zero_extend 5) a)) (zext_b ((_ zero_extend 5) b)))
  (distinct
   ((_ extract 4 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 5) (_ bv5 5))))
   zero
  )
 )
)

(define-fun IC ((s (_ BitVec 5)) (t (_ BitVec 5)) (xlo (_ BitVec 5)) (xhi (_ BitVec 5))) Bool
 (and
  (bvuge (bvnot (bvneg s)) t)
  (=>
   (or (= s zero) (= t ones))
   (mcb xlo xhi t)
  )
  (=>
   (and
    (distinct s zero)
    (distinct t ones)
   )
   (exists ((y (_ BitVec 5)))
    (and
     (mcb xlo xhi (bvadd (bvmul s y) t))
     (not (mulo s y))
     (not (addo (bvmul s y) t))
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 5))) Bool
 (= (bvurem x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 5)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)

