(set-logic BV)

(declare-const s (_ BitVec 16))
(declare-const inv_s (_ BitVec 16))
(declare-const t (_ BitVec 16))
(declare-const xlo (_ BitVec 16))
(declare-const xhi (_ BitVec 16))

(define-fun mcb ((xlo (_ BitVec 16)) (xhi (_ BitVec 16)) (v (_ BitVec 16))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 16))) (_ BitVec 16)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (_ bv16 16) (_ bv15 16)) (_ bv14 16)) (_ bv13 16)) (_ bv12 16)) (_ bv11 16)) (_ bv10 16)) (_ bv9 16)) (_ bv8 16)) (_ bv7 16)) (_ bv6 16)) (_ bv5 16)) (_ bv4 16)) (_ bv3 16)) (_ bv2 16)) (_ bv1 16)) (_ bv0 16))
)

(define-fun clz ((v (_ BitVec 16))) (_ BitVec 16)
 (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv16 16) (_ bv15 16)) (_ bv14 16)) (_ bv13 16)) (_ bv12 16)) (_ bv11 16)) (_ bv10 16)) (_ bv9 16)) (_ bv8 16)) (_ bv7 16)) (_ bv6 16)) (_ bv5 16)) (_ bv4 16)) (_ bv3 16)) (_ bv2 16)) (_ bv1 16)) (_ bv0 16))
)

(define-fun cto ((v (_ BitVec 16))) (_ BitVec 16)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 16))) (_ BitVec 16)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 16))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 16)
 (_ bv0 16)
)

(define-fun one () (_ BitVec 16)
 (_ bv1 16)
)

(define-fun ones () (_ BitVec 16)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 16)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 16)
 (bvnot mins)
)

(define-fun w () (_ BitVec 16)
 (_ bv16 16)
)

(define-fun msb ((v (_ BitVec 16))) (_ BitVec 1)
 ((_ extract 15 15) v)
)

(define-fun IC ((s (_ BitVec 16)) (t (_ BitVec 16)) (xlo (_ BitVec 16)) (xhi (_ BitVec 16))) Bool
 (mcb xlo xhi (bvxor s t))
)

(define-fun LIT ((x (_ BitVec 16))) Bool
 (= (bvxor x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 16)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
