(set-logic BV)

(declare-const s (_ BitVec 1))
(declare-const tn (_ BitVec 1))
(declare-const tx (_ BitVec 1))
(declare-const xlo (_ BitVec 1))
(declare-const xhi (_ BitVec 1))

(define-fun mcb ((xlo (_ BitVec 1)) (xhi (_ BitVec 1)) (v (_ BitVec 1))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 1))) (_ BitVec 1)
 (ite (= ((_ extract 0 0) v) #b0) (_ bv1 1) (_ bv0 1))
)

(define-fun clz ((v (_ BitVec 1))) (_ BitVec 1)
 (ite (= ((_ extract 0 0) v) #b0) (_ bv1 1) (_ bv0 1))
)

(define-fun cto ((v (_ BitVec 1))) (_ BitVec 1)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 1))) (_ BitVec 1)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 1))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 1)
 (_ bv0 1)
)

(define-fun one () (_ BitVec 1)
 (_ bv1 1)
)

(define-fun ones () (_ BitVec 1)
 (bvnot zero)
)

(define-fun w () (_ BitVec 1)
 (_ bv1 1)
)

(define-fun IC ((s (_ BitVec 1)) (tx (_ BitVec 1)) (tn (_ BitVec 1)) (xlo (_ BitVec 1)) (xhi (_ BitVec 1))) Bool
 (and
  (or
   (and (= tn (_ bv0 1)) (= ((_ extract 0 0) tx) #b0))
   (and (= tn (bvnot (_ bv0 1))) (= ((_ extract 0 0) tx) #b1))
  )
  (mcb xlo xhi tx)
 )
)

(define-fun LIT ((x (_ BitVec 1))) Bool
 (= ((_ sign_extend 1) x) (concat tn tx))
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s tx tn xlo xhi)
  (exists ((x (_ BitVec 1)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
