(set-logic BV)

(declare-const s (_ BitVec 11))
(declare-const tn (_ BitVec 1))
(declare-const tx (_ BitVec 11))
(declare-const xlo (_ BitVec 11))
(declare-const xhi (_ BitVec 11))

(define-fun mcb ((xlo (_ BitVec 11)) (xhi (_ BitVec 11)) (v (_ BitVec 11))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 11))) (_ BitVec 11)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (_ bv11 11) (_ bv10 11)) (_ bv9 11)) (_ bv8 11)) (_ bv7 11)) (_ bv6 11)) (_ bv5 11)) (_ bv4 11)) (_ bv3 11)) (_ bv2 11)) (_ bv1 11)) (_ bv0 11))
)

(define-fun clz ((v (_ BitVec 11))) (_ BitVec 11)
 (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv11 11) (_ bv10 11)) (_ bv9 11)) (_ bv8 11)) (_ bv7 11)) (_ bv6 11)) (_ bv5 11)) (_ bv4 11)) (_ bv3 11)) (_ bv2 11)) (_ bv1 11)) (_ bv0 11))
)

(define-fun cto ((v (_ BitVec 11))) (_ BitVec 11)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 11))) (_ BitVec 11)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 11))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 11)
 (_ bv0 11)
)

(define-fun one () (_ BitVec 11)
 (_ bv1 11)
)

(define-fun ones () (_ BitVec 11)
 (bvnot zero)
)

(define-fun w () (_ BitVec 11)
 (_ bv11 11)
)

(define-fun IC ((s (_ BitVec 11)) (tx (_ BitVec 11)) (tn (_ BitVec 1)) (xlo (_ BitVec 11)) (xhi (_ BitVec 11))) Bool
 (and
  (or
   (and (= tn (_ bv0 1)) (= ((_ extract 10 10) tx) #b0))
   (and (= tn (bvnot (_ bv0 1))) (= ((_ extract 10 10) tx) #b1))
  )
  (mcb xlo xhi tx)
 )
)

(define-fun LIT ((x (_ BitVec 11))) Bool
 (= ((_ sign_extend 1) x) (concat tn tx))
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s tx tn xlo xhi)
  (exists ((x (_ BitVec 11)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
