(set-logic BV)

(declare-const s (_ BitVec 17))
(declare-const tn (_ BitVec 2))
(declare-const tx (_ BitVec 17))
(declare-const xlo (_ BitVec 17))
(declare-const xhi (_ BitVec 17))

(define-fun mcb ((xlo (_ BitVec 17)) (xhi (_ BitVec 17)) (v (_ BitVec 17))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 17))) (_ BitVec 17)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (_ bv17 17) (_ bv16 17)) (_ bv15 17)) (_ bv14 17)) (_ bv13 17)) (_ bv12 17)) (_ bv11 17)) (_ bv10 17)) (_ bv9 17)) (_ bv8 17)) (_ bv7 17)) (_ bv6 17)) (_ bv5 17)) (_ bv4 17)) (_ bv3 17)) (_ bv2 17)) (_ bv1 17)) (_ bv0 17))
)

(define-fun clz ((v (_ BitVec 17))) (_ BitVec 17)
 (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv17 17) (_ bv16 17)) (_ bv15 17)) (_ bv14 17)) (_ bv13 17)) (_ bv12 17)) (_ bv11 17)) (_ bv10 17)) (_ bv9 17)) (_ bv8 17)) (_ bv7 17)) (_ bv6 17)) (_ bv5 17)) (_ bv4 17)) (_ bv3 17)) (_ bv2 17)) (_ bv1 17)) (_ bv0 17))
)

(define-fun cto ((v (_ BitVec 17))) (_ BitVec 17)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 17))) (_ BitVec 17)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 17))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 17)
 (_ bv0 17)
)

(define-fun one () (_ BitVec 17)
 (_ bv1 17)
)

(define-fun ones () (_ BitVec 17)
 (bvnot zero)
)

(define-fun w () (_ BitVec 17)
 (_ bv17 17)
)

(define-fun IC ((s (_ BitVec 17)) (tx (_ BitVec 17)) (tn (_ BitVec 2)) (xlo (_ BitVec 17)) (xhi (_ BitVec 17))) Bool
 (and
  (or
   (and (= tn (_ bv0 2)) (= ((_ extract 16 16) tx) #b0))
   (and (= tn (bvnot (_ bv0 2))) (= ((_ extract 16 16) tx) #b1))
  )
  (mcb xlo xhi tx)
 )
)

(define-fun LIT ((x (_ BitVec 17))) Bool
 (= ((_ sign_extend 2) x) (concat tn tx))
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s tx tn xlo xhi)
  (exists ((x (_ BitVec 17)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
