(set-logic BV)

(declare-const s (_ BitVec 10))
(declare-const tn (_ BitVec 3))
(declare-const tx (_ BitVec 10))
(declare-const xlo (_ BitVec 10))
(declare-const xhi (_ BitVec 10))

(define-fun mcb ((xlo (_ BitVec 10)) (xhi (_ BitVec 10)) (v (_ BitVec 10))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 10))) (_ BitVec 10)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (_ bv10 10) (_ bv9 10)) (_ bv8 10)) (_ bv7 10)) (_ bv6 10)) (_ bv5 10)) (_ bv4 10)) (_ bv3 10)) (_ bv2 10)) (_ bv1 10)) (_ bv0 10))
)

(define-fun clz ((v (_ BitVec 10))) (_ BitVec 10)
 (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv10 10) (_ bv9 10)) (_ bv8 10)) (_ bv7 10)) (_ bv6 10)) (_ bv5 10)) (_ bv4 10)) (_ bv3 10)) (_ bv2 10)) (_ bv1 10)) (_ bv0 10))
)

(define-fun cto ((v (_ BitVec 10))) (_ BitVec 10)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 10))) (_ BitVec 10)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 10))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 10)
 (_ bv0 10)
)

(define-fun one () (_ BitVec 10)
 (_ bv1 10)
)

(define-fun ones () (_ BitVec 10)
 (bvnot zero)
)

(define-fun w () (_ BitVec 10)
 (_ bv10 10)
)

(define-fun IC ((s (_ BitVec 10)) (tx (_ BitVec 10)) (tn (_ BitVec 3)) (xlo (_ BitVec 10)) (xhi (_ BitVec 10))) Bool
 (and
  (or
   (and (= tn (_ bv0 3)) (= ((_ extract 9 9) tx) #b0))
   (and (= tn (bvnot (_ bv0 3))) (= ((_ extract 9 9) tx) #b1))
  )
  (mcb xlo xhi tx)
 )
)

(define-fun LIT ((x (_ BitVec 10))) Bool
 (= ((_ sign_extend 3) x) (concat tn tx))
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s tx tn xlo xhi)
  (exists ((x (_ BitVec 10)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
