(set-logic BV)

(declare-const s (_ BitVec 12))
(declare-const tn (_ BitVec 3))
(declare-const tx (_ BitVec 12))
(declare-const xlo (_ BitVec 12))
(declare-const xhi (_ BitVec 12))

(define-fun mcb ((xlo (_ BitVec 12)) (xhi (_ BitVec 12)) (v (_ BitVec 12))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 12))) (_ BitVec 12)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (_ bv12 12) (_ bv11 12)) (_ bv10 12)) (_ bv9 12)) (_ bv8 12)) (_ bv7 12)) (_ bv6 12)) (_ bv5 12)) (_ bv4 12)) (_ bv3 12)) (_ bv2 12)) (_ bv1 12)) (_ bv0 12))
)

(define-fun clz ((v (_ BitVec 12))) (_ BitVec 12)
 (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv12 12) (_ bv11 12)) (_ bv10 12)) (_ bv9 12)) (_ bv8 12)) (_ bv7 12)) (_ bv6 12)) (_ bv5 12)) (_ bv4 12)) (_ bv3 12)) (_ bv2 12)) (_ bv1 12)) (_ bv0 12))
)

(define-fun cto ((v (_ BitVec 12))) (_ BitVec 12)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 12))) (_ BitVec 12)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 12))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 12)
 (_ bv0 12)
)

(define-fun one () (_ BitVec 12)
 (_ bv1 12)
)

(define-fun ones () (_ BitVec 12)
 (bvnot zero)
)

(define-fun w () (_ BitVec 12)
 (_ bv12 12)
)

(define-fun IC ((s (_ BitVec 12)) (tx (_ BitVec 12)) (tn (_ BitVec 3)) (xlo (_ BitVec 12)) (xhi (_ BitVec 12))) Bool
 (and
  (or
   (and (= tn (_ bv0 3)) (= ((_ extract 11 11) tx) #b0))
   (and (= tn (bvnot (_ bv0 3))) (= ((_ extract 11 11) tx) #b1))
  )
  (mcb xlo xhi tx)
 )
)

(define-fun LIT ((x (_ BitVec 12))) Bool
 (= ((_ sign_extend 3) x) (concat tn tx))
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s tx tn xlo xhi)
  (exists ((x (_ BitVec 12)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
