(set-logic BV)

(declare-const s (_ BitVec 8))
(declare-const tn (_ BitVec 3))
(declare-const tx (_ BitVec 8))
(declare-const xlo (_ BitVec 8))
(declare-const xhi (_ BitVec 8))

(define-fun mcb ((xlo (_ BitVec 8)) (xhi (_ BitVec 8)) (v (_ BitVec 8))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 8))) (_ BitVec 8)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (_ bv8 8) (_ bv7 8)) (_ bv6 8)) (_ bv5 8)) (_ bv4 8)) (_ bv3 8)) (_ bv2 8)) (_ bv1 8)) (_ bv0 8))
)

(define-fun clz ((v (_ BitVec 8))) (_ BitVec 8)
 (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv8 8) (_ bv7 8)) (_ bv6 8)) (_ bv5 8)) (_ bv4 8)) (_ bv3 8)) (_ bv2 8)) (_ bv1 8)) (_ bv0 8))
)

(define-fun cto ((v (_ BitVec 8))) (_ BitVec 8)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 8))) (_ BitVec 8)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 8))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 8)
 (_ bv0 8)
)

(define-fun one () (_ BitVec 8)
 (_ bv1 8)
)

(define-fun ones () (_ BitVec 8)
 (bvnot zero)
)

(define-fun w () (_ BitVec 8)
 (_ bv8 8)
)

(define-fun IC ((s (_ BitVec 8)) (tx (_ BitVec 8)) (tn (_ BitVec 3)) (xlo (_ BitVec 8)) (xhi (_ BitVec 8))) Bool
 (and
  (or
   (and (= tn (_ bv0 3)) (= ((_ extract 7 7) tx) #b0))
   (and (= tn (bvnot (_ bv0 3))) (= ((_ extract 7 7) tx) #b1))
  )
  (mcb xlo xhi tx)
 )
)

(define-fun LIT ((x (_ BitVec 8))) Bool
 (= ((_ sign_extend 3) x) (concat tn tx))
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s tx tn xlo xhi)
  (exists ((x (_ BitVec 8)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
