(set-logic BV)

(declare-const s (_ BitVec 26))
(declare-const tn (_ BitVec 4))
(declare-const tx (_ BitVec 26))
(declare-const xlo (_ BitVec 26))
(declare-const xhi (_ BitVec 26))

(define-fun mcb ((xlo (_ BitVec 26)) (xhi (_ BitVec 26)) (v (_ BitVec 26))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 26))) (_ BitVec 26)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (_ bv26 26) (_ bv25 26)) (_ bv24 26)) (_ bv23 26)) (_ bv22 26)) (_ bv21 26)) (_ bv20 26)) (_ bv19 26)) (_ bv18 26)) (_ bv17 26)) (_ bv16 26)) (_ bv15 26)) (_ bv14 26)) (_ bv13 26)) (_ bv12 26)) (_ bv11 26)) (_ bv10 26)) (_ bv9 26)) (_ bv8 26)) (_ bv7 26)) (_ bv6 26)) (_ bv5 26)) (_ bv4 26)) (_ bv3 26)) (_ bv2 26)) (_ bv1 26)) (_ bv0 26))
)

(define-fun clz ((v (_ BitVec 26))) (_ BitVec 26)
 (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv26 26) (_ bv25 26)) (_ bv24 26)) (_ bv23 26)) (_ bv22 26)) (_ bv21 26)) (_ bv20 26)) (_ bv19 26)) (_ bv18 26)) (_ bv17 26)) (_ bv16 26)) (_ bv15 26)) (_ bv14 26)) (_ bv13 26)) (_ bv12 26)) (_ bv11 26)) (_ bv10 26)) (_ bv9 26)) (_ bv8 26)) (_ bv7 26)) (_ bv6 26)) (_ bv5 26)) (_ bv4 26)) (_ bv3 26)) (_ bv2 26)) (_ bv1 26)) (_ bv0 26))
)

(define-fun cto ((v (_ BitVec 26))) (_ BitVec 26)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 26))) (_ BitVec 26)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 26))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 26)
 (_ bv0 26)
)

(define-fun one () (_ BitVec 26)
 (_ bv1 26)
)

(define-fun ones () (_ BitVec 26)
 (bvnot zero)
)

(define-fun w () (_ BitVec 26)
 (_ bv26 26)
)

(define-fun IC ((s (_ BitVec 26)) (tx (_ BitVec 26)) (tn (_ BitVec 4)) (xlo (_ BitVec 26)) (xhi (_ BitVec 26))) Bool
 (and
  (or
   (and (= tn (_ bv0 4)) (= ((_ extract 25 25) tx) #b0))
   (and (= tn (bvnot (_ bv0 4))) (= ((_ extract 25 25) tx) #b1))
  )
  (mcb xlo xhi tx)
 )
)

(define-fun LIT ((x (_ BitVec 26))) Bool
 (= ((_ sign_extend 4) x) (concat tn tx))
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s tx tn xlo xhi)
  (exists ((x (_ BitVec 26)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
